package nl.tudelft.ewi.es.mbdlistener.diagnoser;

public enum EnvironmentType {
	None(0,0), Link(1,4), Node(2,2), Sensor(3,2);
	private final int id;
	private final int size;

	private EnvironmentType(int id, int size) {
		this.id = id;
		this.size = size;
	}
	public int getId() {
		return id;
	}
	public int getSize() {
		return size;
	}
	
	public static EnvironmentType byID(int id) {
		for ( EnvironmentType envType : EnvironmentType.values()) {
			if (envType.getId() == id)
				return envType;
		}
		return None;
	}
}
