package nl.tudelft.ewi.es.mbdlistener.input;

import nl.tudelft.ewi.es.mbdlistener.events.EventList;

public abstract class ListenerInput {
	protected EventList eventList;
	
	/**
	 * Creates a new listener input, that outputs events into the given event list
	 * @param eventList the list to add events to
	 */
	public ListenerInput(EventList eventList) {
		this.eventList = eventList;
	}

	/**
	 * Starts an input plugin
	 */
	public abstract void start();
}
