#!/usr/bin/python
'''
Created on May 5, 2009

@author: adriaan
'''
import re;
import sys;

if __name__ == '__main__':
#    f = open("idealised_1_stdout.out", "r");
#    lines = f.readlines();
    started = False;
    dbgHead = "DEBUG \(\d{1,2}\): ";
    errHead = "ERROR \(\d{1,2}\): ";
    tmpConflict = "";
    
    
#    for line in lines:
    for line in sys.stdin:

        if line.startswith("Starting run"):
            if not started:
                print "<?xml version='1.0' ?>"
                print "<run>";
                started = True;
        elif re.match("DEBUG \((\d{1,2})\): Root received conflict from (\d{1,2}); id: (\d{1,4}), size: (\d{1,2}), Env: (.*)$", line):
            result = re.match("DEBUG \((\d{1,2})\): Root received conflict from (\d{1,2}); id: (\d{1,4}), size: (\d{1,2}), Env: (.*)$", line);
            print "<conflict serial_source='" + result.group(1) + "' source='" + result.group(2) + "' id='" + result.group(3) +"'",
            tmpConflict = "' >\n";
            envs = result.group(5).split(",");
            envs.pop();
            for env in envs:
                nodematch = re.match("\s*Node (\d{1,2})", env);
                sensormatch = re.match("\s*Sensor (\d{1,2})", env);
                linkmatch = re.match("\s*Link \((\d{1,2}) to (\d{1,2})\)", env);
                if nodematch:
                    tmpConflict += "\t<env_node nodeId='" + nodematch.group(1) +"' />\n";
                elif sensormatch:
                    tmpConflict += "\t<env_sensor nodeId='" + sensormatch.group(1) +"' />\n";
                elif linkmatch:
                    tmpConflict += "\t<env_link sender='" + linkmatch.group(1) +"' receiver='" + linkmatch.group(2) + "' />\n";
                elif env == "":
                    pass
                else:
                    print "Invalid environment", env;
                    sys.exit();
            tmpConflict += "</conflict>";
        elif re.match("DEBUG \((\d+)\): Sensor dying", line):
            result = re.match("DEBUG \((\d+)\): Sensor dying", line)
            print "<sensor_death_message serial_source='" + result.group(1) + "' source='" + result.group(1) + "'",;
            tmpConflict = "' />"
        elif re.match("DEBUG \(0\): Root received conflict invalidation from (\d{1,2}), id: (\d{1,4})", line):
            result = re.match("DEBUG \(0\): Root received conflict invalidation from (\d{1,2}), id: (\d{1,4})", line);
            print "<conflict_cancelled serial_source='0' source='" + result.group(1) + "' id='" + result.group(2) + "'",;
            tmpConflict = "' />"
            pass

        elif re.match("(\d+). Message <SerialConflictMessage", line):
            result = re.match("(\d+) Message <SerialConflictMessage", line)
            time = int(result.group(1));
            print "timestamp='" + str(time) + tmpConflict
#            print line,
            pass;
        elif line.startswith("  [source="):
            pass;
        elif line.startswith("  [conflict."):
            pass;
        elif re.match("(\d+) \((\d{1,2})\) Node sent or intercepted conflict!", line):
            result = re.match("(\d+) \((\d{1,2})\) Node sent or intercepted conflict!", line);
            print("<conflict_message serial_source='" + result.group(2) + "' timestamp='"+ result.group(1) + "' />");
            pass;
        elif re.match("(\d+) \((\d{1,2})\) Node dying now!", line):
            result = re.match("(\d+) \((\d{1,2})\) Node dying now!", line);
            print "<node_death_message serial_source='" + result.group(2) + "' timestamp='" +result.group(1) + "' />";
            pass;
        elif re.match("\d+ 2 \d{1,2} \d+ \d+ \d+", line):
            pass;
        elif re.match("\d+ 3 \d{1,2} \d+ \d+ \d+", line):
            pass;
        elif re.match("\d+ 4 \d{1,2} \d+ \d+ \d+", line):
            pass;
        elif re.match(dbgHead + "Node sent conflict;", line):
            pass;
        elif re.match(dbgHead + "Node sent invalidated conflict;", line):
            pass;
        elif line.startswith("SocketIO"):
            pass;
        elif re.match("^\s*$", line):
            pass;
        elif re.match("\s*\d{1,2}\s*->\s*\d{1,2}\s*-\d{1,3}.\d{2}", line):
            pass; 
        elif line.startswith("Creating noise model for"):
            pass;
        elif line.startswith("clients "):
            pass;
        elif re.match("\d+\s+\(\d{1,2}\) Tree sent beacon", line):
#            print "matched:", line
            pass; 
        elif line.startswith("DEBUG (0): Node ID 0, setting self as root"):
            pass;
        elif re.match(dbgHead + "Node will die at ", line):
            pass;
        elif re.match(dbgHead + "Killing routing", line):
            pass;
        elif re.match("\d+ \(\d{1,2}\) Node dying at \d+", line):
            pass;
        elif re.match(dbgHead + "Quality route to", line):
            pass;
        elif re.match(dbgHead + "Could not send, but radio should not be busy", line):
            pass;
        elif re.match(dbgHead + "Received beacon from \d{1,2} = FALSE", line):
            pass;
        elif re.match(dbgHead + "sendDone does not report success", line):
            pass
        elif re.match(errHead + "route quality too bad, skipping", line):
            pass
        elif re.match(errHead + "No nodes added, due to bad route quality", line):
            pass
        else:
            print line,;
            pass
    print "</run>";