package nl.tudelft.ewi.es.mbdlistener.diagnoser;


public class LinkEnvironment extends Environment {
	private static final long serialVersionUID = 1L;
	private int sender;
	private int receiver;
		
	public LinkEnvironment(short[] env, int initialIndex) {
		sender = (env[initialIndex] << 8) + env[initialIndex+1];
		receiver = (env[initialIndex+2] << 8) + env[initialIndex+3];
	}
	
	public LinkEnvironment(int sender, int receiver) {
		this.sender = sender;
		this.receiver = receiver;
	}
	@Override
	public String toString() {
		return "Link (" + sender + ", " + receiver +")";
	}
	public Integer getReceiver() {
		return receiver;
	}
	public Integer getSender() {
		return sender;
	}
}
