package nl.tudelft.ewi.es.mbdlistener.events;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observable;


public class EventList extends Observable implements Iterable<ListenerEvent>{
	private ArrayList<ListenerEvent> eventList = new ArrayList<ListenerEvent>();
	
	public boolean add(ListenerEvent e) {
		setChanged();
		notifyObservers(e);
		return eventList.add(e);
	}

	public void clear() {
		setChanged();
		notifyObservers();
		eventList.clear();
	}

//	public boolean contains(Object o) {
//		return eventList.contains(o);
//	}
//
//	public ListenerEvent get(int index) {
//		return eventList.get(index);
//	}
//
//	public int indexOf(Object o) {
//		return eventList.indexOf(o);
//	}
//
//	public boolean isEmpty() {
//		return eventList.isEmpty();
//	}

	@Override
	public Iterator<ListenerEvent> iterator() {
		return eventList.iterator();
	}

//	public boolean remove(Object o) {
//		return eventList.remove(o);
//	}

//	public ListenerEvent remove(int index) {
//		return eventList.remove(index);
//	}

//	public int size() {
//		return eventList.size();
//	}
}
