package nl.tudelft.ewi.es.mbdlistener.graphics;

import java.util.ArrayList;
import java.util.List;

import nl.tudelft.ewi.es.mbdlistener.diagnoser.Conflict;
import nl.tudelft.ewi.es.mbdlistener.diagnoser.Diagnosis;

public class ConflictDiagnoserEvent extends DiagnoserEvent {
	private Conflict conflict;
	
	public ConflictDiagnoserEvent(List<Diagnosis> previousDiagnosis, Conflict conflict) {
		super(previousDiagnosis);
		this.conflict = conflict;
	}
	
	public ConflictDiagnoserEvent(Conflict conflict) {
		super(new ArrayList<Diagnosis>());
		this.conflict = conflict;
	}
	@Override
	public String toString() {
		return "Conflict: " + conflict;
	}
}
