package nl.tudelft.ewi.es.mbdlistener.graphics;

import java.util.ArrayList;
import java.util.List;

import nl.tudelft.ewi.es.mbdlistener.diagnoser.Diagnosis;

public abstract class DiagnoserEvent {
	private static final long serialVersionUID = 1L;

	private List<Diagnosis> diagnoses;

	public DiagnoserEvent(List<Diagnosis> diagnoses) {
		this.diagnoses = diagnoses;
	}
	public List<Diagnosis> getDiagnoses() {
		return diagnoses;
	}
	public void setDiagnoses(List<Diagnosis> list) {
		this.diagnoses = new ArrayList<Diagnosis>(list);
	}
	
}
