#!/usr/bin/python
'''
Created on May 5, 2009

@author: adriaan
'''
import re;
import sys;

if __name__ == '__main__':
    use_tossim_time = False
    if len(sys.argv) == 2:
	binsize = float(sys.argv[1])
	column = 0
    elif len(sys.argv) == 3:
	binsize = float(sys.argv[1])
	column = int(sys.argv[2])
    elif len(sys.argv) == 4:
	binsize = float(sys.argv[1])
	column = int(sys.argv[2])
	use_tossim_time = True
    else:
	print "Usage:", sys.argv[0], "<binsize> [column] [use_tossim_time]"
	sys.exit(0);

    hist = dict()
    for line in sys.stdin:
	if line == "\n":
	    continue	
	if line.startswith("#"):
	    continue
	if line.startswith("\t"):
	    continue
	if line.startswith("Conflict"):
	    continue
	s = line.split()
	if s[column] == "\"\"":
	    continue
	num = 0.0;
	if s[column] == "inf":
#	    print "found inf"
	    binnum = -2
	    num = -2.0
	else:
	    num = float(s[column])
	    if use_tossim_time:
		num /= 10000
	    binnum = int(num/binsize)
	
#	print binnum, num
#	if hist.get
	if binnum in hist:
	    hist[binnum] += 1
	else:
	    hist[binnum] = 1
    if (len(hist) == 0):
	print 0,0
	sys.exit(0)
    
    for i in range (0, max(hist.keys()) + 1):
#	print "\"" + str(i*binsize), "-", str((i+1)*binsize) +"\"",
	print "\"%.0f - %.0f\"" % (i*binsize, (i+1)*binsize),
	if i in hist:
	    print hist[i]
	else:
	    print 0
    if -2 in hist:
	print "\"Not found\"", hist[-2]
    else:
	print "\"Not found\"", 0

#    for i in range (-3, max(hist.keys()) + 2):
#	if i in hist:
#	    print "\"", i*binsize, "-", (i+1)*binsize, "\"",
#	    print hist[i]
#	else:
#	    print "\"\" ",
#	    print 0

#	print key*binsize, value
	