# !/bin/bash
#PREFIXES="idealised noisy1 noisy2 noisy_dense"
PREFIXES="noisy2"
DIRS="config_0"
#RUNS="0 1 2 3 4 5 6 7 8 9 10"
RUNS="10"

CLASSPATH=$CLASSPATH:/home/adriaan/svn/TestMBD/MbdListener/bin/:/home/adriaan/svn/commons-cli-1.2.jar
for DIR in $DIRS; do
    if [ -d $DIR ]; then
	for PREFIX in $PREFIXES; do
	    pushd "$DIR"
	    echo "#!/usr/bin/gnuplot -persist" > "../${DIR}_${PREFIX}.sh"
	    echo "set xrange [500:3600]" >> "../${DIR}_${PREFIX}.sh"
	    echo "set yrange [0:3.5]" >> "../${DIR}_${PREFIX}.sh"
	    echo "set ylabel 'Number of nodes'" >> "../${DIR}_${PREFIX}.sh"
	    echo "set xlabel 'Time(s)'" >> "../${DIR}_${PREFIX}.sh"
#	    echo "set x2label 'Nodes Missed'" >> "../${DIR}_${PREFIX}.sh"
#	    echo "set x2tics rotate" >> "../${DIR}_${PREFIX}.sh"
#	    echo "set y2range [0:300]" >> "../${DIR}_${PREFIX}.sh"
	    echo "set y2label 'Message count (cumulative)'" >> "../${DIR}_${PREFIX}.sh"
	    echo "set y2tics" >> "../${DIR}_${PREFIX}.sh"
	    echo "set key left top" >> "../${DIR}_${PREFIX}.sh"
	    chmod +x "../${DIR}_${PREFIX}.sh"


	    for RUN in $RUNS; do
		FILE="${PREFIX}_${RUN}_stdout.out"
#	    for FILE in `ls $PREFIX*stdout.out`; do
		echo "set output" >> "../${DIR}_${PREFIX}.sh"
		echo "set terminal dumb" >> "../${DIR}_${PREFIX}.sh"
		echo "set size 1,1" >> "../${DIR}_${PREFIX}.sh"
		
		echo "set title '$DIR.$FILE'" >> "../${DIR}_${PREFIX}.sh"
		echo "0 0 0 0 0" >  ../"$DIR.$FILE.plot"
		cat "$FILE" |parser | java nl.tudelft.ewi.es.mbdlistener.MbdListener -ix -ixto -cp >> ../"$DIR.$FILE.plot"
		cat "${FILE}" |parser |msgcounter  >> ../"${DIR}.${FILE}_msg.plot"
		echo "100000000 0 0 0 0" >>  ../"$DIR.$FILE.plot"
#		cat ../"$DIR.$FILE.plot" |grep label >> "../${DIR}_${PREFIX}.sh"
#		cat ../"$DIR.$FILE.plot" |grep -v label > ../"$DIR.$FILE.plot"
		echo "plot '$DIR.$FILE.plot' using 1:2 with steps lc rgb 'red' title '$FILE sensor false positives', '$DIR.$FILE.plot' using 1:2 with points lc rgb 'red' notitle"  >> "../${DIR}_${PREFIX}.sh"
		echo "replot '$DIR.$FILE.plot' u 1:3:x2ticlabels(10) with steps lc rgb 'blue' title '$FILE node false positives', '$DIR.$FILE.plot' u 1:3 with points lc rgb 'blue' notitle"  >> "../${DIR}_${PREFIX}.sh"
		echo "replot '$DIR.$FILE.plot' u 1:4 with steps lc rgb 'green' title '$FILE sensors missed', '$DIR.$FILE.plot' u 1:4 with points lc rgb 'green' notitle"  >> "../${DIR}_${PREFIX}.sh"
		echo "replot '$DIR.$FILE.plot' u 1:5 with steps lc rgb 'orange' title '$FILE nodes missed', '$DIR.$FILE.plot' u 1:5 with points lc rgb 'orange' notitle" >> "../${DIR}_${PREFIX}.sh"
		echo "replot '$DIR.$FILE.plot' u 1:4:6 with labels rotate left offset 0,0.5 lc rgb 'orange' notitle" >> "../${DIR}_${PREFIX}.sh"
		echo "replot '$DIR.$FILE.plot' u 1:5:7 with labels rotate left offset 0,0.5 lc rgb 'orange' notitle" >> "../${DIR}_${PREFIX}.sh"
#		echo "replot '${DIR}.${FILE}_msg.plot' using 1:2 with l lc rgb 'grey' title '${FILE} message count' axes x1y2"   >> "../${DIR}_${PREFIX}.sh"
#		echo "set yrange [0:3.5]" >> "../${DIR}_${PREFIX}.sh"

	        echo "set terminal postscript eps enhanced" >> "../${DIR}_${PREFIX}.sh"
		echo "set output '$DIR.$FILE.eps'" >> "../${DIR}_${PREFIX}.sh"
		echo "set size 1.8,1.8" >> "../${DIR}_${PREFIX}.sh"
	        echo "replot" >> "../${DIR}_${PREFIX}.sh"

		echo "set output '${DIR}.${FILE}_with_msgs.eps'" >> "../${DIR}_${PREFIX}.sh"
		echo "set size 1.8,1.8" >> "../${DIR}_${PREFIX}.sh"
	        echo "replot" >> "../${DIR}_${PREFIX}.sh"
		echo "replot '${DIR}.${FILE}_msg.plot' using 1:2 with l lc rgb 'grey' title '${FILE} message count' axes x1y2"   >> "../${DIR}_${PREFIX}.sh"

#		echo "set size 1.8,1.8" >> "../${DIR}_${PREFIX}.sh"
#		echo "set yrange [0:2.5]" >> "../${DIR}_${PREFIX}.sh"

#	        echo "set terminal postscript eps" >> "../${DIR}_${PREFIX}.sh"

		echo "Finished $FILE"
	    done
            popd
#	    ./${DIR}_${PREFIX}.sh
	done
    fi
done
